		TITLE	"8008 1975 opcodes Test Source File - better"
		PAGE	60

; note: default radix for this 8008 assembler is OCTAL
;
; The 8008 opcodes not quite in opcode numerical order:
;
BYTE		EQU	012H
WORD		EQU	034H
ADDRESS		EQU	07890H

; 000 - 017.


		INR	A	;*HLT
		DCR	A	;*HLT

		RLC
		RNC


		ADI	BYTE
		RST	0
		MVI	A, BYTE
		RET

		INR	B
		DCR	B
		RRC
		RNZ
		ACI	BYTE
		RST	1


		MVI	B, BYTE
		;17 is unused RET

;20-37
					
		INR	C
		DCR	C
		RAL
		RP

		SUI	BYTE
		RST	2


		MVI	C, BYTE
		;27 is unused RET

					
		INR	D
		DCR	D
		RAR
		RPO
		SBI	BYTE
		RST	3

		MVI	D, BYTE
		;37 is unused RET


; 40-57
					
		INR	E
		DCR	E
		;42 is undefined
		RC

		ANI	BYTE


		RST	4

		MVI	E, BYTE
		;47 is unused RET


		INR	H
		DCR	H
		;52 is undefined

		RZ
		XRI	BYTE
		RST	5



		MVI	H, BYTE
		;57 is unused RET

;60-77

		INR	L
		DCR	L
		;62 is undefined

		RM
		ORI	BYTE
		RST	6

		MVI	L, BYTE
		;67 is unused RET

		INR	M	;70 is undefined!
		DCR	M	;71 is undefined!
		;72 is undefined

		RPE
		CPI	BYTE
		RST	7

		MVI	M, BYTE
		;77 is unused RET

;100  IN and OUT ports. 
;IN is 0-7, OUT is 10-37 octal (8-31 dec) only
;should have three errors with IN, OUT

		IN	0
		IN	1
		IN	2
		IN	3
		IN	4
		IN	5
		IN	6
		IN	7
		IN	10	;should be error

		OUT	7	;should be error
		OUT	10	;decimal 8, octal 10
		OUT	11
		OUT	12
		OUT	13
		OUT	14
		OUT	15
		OUT	16
		OUT	17
		OUT	20
		OUT	27
		OUT	30
		OUT	37
		OUT	40	;should be error	


;100 call and jump

		JNC	ADDRESS
		CNC	ADDRESS
		
		JMP	ADDRESS
		CALL	ADDRESS

		JNZ	ADDRESS
		CNZ	ADDRESS

		;114	bad JMP
		;116	bad call


;120 call and jump

		JP	ADDRESS
		CP	ADDRESS

		;124	bad JMP
		;126	bad CALL

		JPO	ADDRESS
		CPO	ADDRESS

		;134	bad JMP
		;136	bad CALL

;140 call and jump

		JC	ADDRESS
		CC	ADDRESS

		;144	bad JMP
		;146	bad CALL
					

		JZ	ADDRESS		
				
		CZ	ADDRESS
		;154	bad JMP
		;156	bad CALL

;160 call and jump

		JM	ADDRESS
		CM	ADDRESS
		;164	bad JMP
		;166	bad CALL


		JPE	ADDRESS
		CPE	ADDRESS
		;174	bad JMP
		;176	bad CALL

;200-217

		ADD	A
		ADD	B
		ADD	C
		ADD	D
		ADD	E
		ADD	H
		ADD	L
		ADD	M

		ADC	A
		ADC	B
		ADC	C
		ADC	D
		ADC	E
		ADC	H
		ADC	L
		ADC	M


;220-237

		SUB	A
		SUB	B
		SUB	C
		SUB	D
		SUB	E
		SUB	H
		SUB	L
		SUB	M

		SBB	A
		SBB	B
		SBB	C
		SBB	D
		SBB	E
		SBB	H
		SBB	L
		SBB	M


;240-257

		ANA	A
		ANA	B
		ANA	C
		ANA	D
		ANA	E
		ANA	H
		ANA	L
		ANA	M

		XRA	A
		XRA	B
		XRA	C
		XRA	D
		XRA	E
		XRA	H
		XRA	L
		XRA	M


;260-277

		ORA	A
		ORA	B
		ORA	C
		ORA	D
		ORA	E
		ORA	H
		ORA	L
		ORA	M

		CMP	A
		CMP	B
		CMP	C
		CMP	D
		CMP	E
		CMP	H
		CMP	L
		CMP	M

;300-317

		NOP

		MOV	A, A	;note this is a no-op
		MOV	A, B
		MOV	A, C
		MOV	A, D
		MOV	A, E
		MOV	A, H
		MOV	A, L
		MOV	A, M

		MOV	B, A
		MOV	B, B
		MOV	B, C
		MOV	B, D
		MOV	B, E
		MOV	B, H
		MOV	B, L
		MOV	B, M
;320-337
		MOV	C, A
		MOV	C, B
		MOV	C, C
		MOV	C, D
		MOV	C, E
		MOV	C, H
		MOV	C, L
		MOV	C, M



		MOV	D, A
		MOV	D, B
		MOV	D, C
		MOV	D, D
		MOV	D, E
		MOV	D, H
		MOV	D, L
		MOV	D, M

;340-357
		MOV	E, A
		MOV	E, B
		MOV	E, C
		MOV	E, D
		MOV	E, E
		MOV	E, H
		MOV	E, L
		MOV	E, M

		MOV	H, A
		MOV	H, B
		MOV	H, C
		MOV	H, D
		MOV	H, E
		MOV	H, H
		MOV	H, L
		MOV	H, M
;360-377

		MOV	L, A
		MOV	L, B
		MOV	L, C
		MOV	L, D
		MOV	L, E
		MOV	L, H
		MOV	L, L
		MOV	L, M


		MOV	M, A
		MOV	M, B
		MOV	M, C
		MOV	M, D
		MOV	M, E
		MOV	M, H
		MOV	M, L
		HLT

;
; Let's test the rest of the pseudo-ops while we're at it:
;
VARIABLE	SET	-1

		IF	VARIABLE
		DB	-1
		ELSE
		DB	+1
		ENDIF

VARIABLE	SET	VARIABLE EQ 0

		IF	VARIABLE
		DW	+1
		ELSE
		DW	-1
		ENDIF

		DS	10H

;are the following good expressions?
		DB	-1,,1
		DB	1, ,-1
		DB	"EXPLOSION", 0DH, 0AH, 0
		DB	'BOOM',"X"

; extended instructions

		LXI	B,34H	;creates same as
		MVI	c,34H
		MVI	B,00H

		LXI	D,1234H	;creates same as
		MVI	E,34H
		MVI	D,12H
	
		LXI	H,1234H	;creates same as
		MVI	L,34H
		MVI	H,12H
		

		END


