;intel 8008 opcodes for 1975 
	org	0000H
d8	equ	55H
a16	equ	1000H

;opcodes 00-0F
	RLC 
	RNC 
	ADI d8 
	RST 0 
	MVI A,d8 
	RET 
	INR B 
	DCR B 
	RRC 
	RNZ 
	ACI d8 
	RST 1 
	MVI B,d8
;opcodes 10-1F
	INR C 
	DCR C 
	RAL 
	RP 
	SUI d8 
	RST 2 
	MVI C,d8 
	INR D 
	DCR D 
	RAR 
	RPO 
	SBI d8 
	RST 3 
	MVI D,d8
;opcodes 20-2F
	INR E 
	DCR E 
	RC 
	ANI d8 
	RST 4 
	MVI E,d8 
	INR H 
	DCR H 
	RZ 
	XRI d8 
	RST 5 
	MVI H,d8
;opcodes 30-3F
	INR L 
	DCR L 
	RM 
	ORI d8 
	RST 6 
	MVI L,d8 
	RPE 
	CPI d8 
	RST 7 
	MVI M,d8
;opcodes 40-4F
	JNC a16 
	IN 0 
	CNC a16 
	IN 1 
	JMP a16 
	IN 2 
	CALL a16 
	IN 3 
	JNZ a16 
	IN 4 
	CNZ a16 
	IN 5 
	IN 6 
	IN 7
;opcodes 50-5F
	JP a16 
	OUT 10 
	CP a16 
	OUT 11 
	OUT 12 
	OUT 13 
	JPO a16 
	OUT 14 
	CPO a16 
	OUT 15 
	OUT 16 
	OUT 17
;opcodes 60-6F
	JC a16 
	OUT 20 
	CC a16 
	OUT 21 
	OUT 22  
	OUT 23 
	JZ a16 
	OUT 24 
	CZ a16 
	OUT 25 
	OUT 26 
	OUT 27
;opcodes 70-7F
	JM a16
	OUT 30
	CM a16
	OUT 31
	OUT 32
	OUT 33
	JPE a16
	OUT 34
	CPE a16
	OUT 35
	OUT 36
	OUT 37
;opcodes 80-8F
	ADD A
	ADD B
	ADD C
	ADD D
	ADD E
	ADD H
	ADD L
	ADD M
	ADC A
	ADC B
	ADC C
	ADC D
	ADC E
	ADC H
	ADC L
	ADC M
;opcodes 90-9F
	SUB A
	SUB B
	SUB C
	SUB D
	SUB E
	SUB H
	SUB L
	SUB M
	SBB A
	SBB B
	SBB C
	SBB D
	SBB E
	SBB H
	SBB L
	SBB M
;opcodes A0-AF
	ANA A
	ANA B
	ANA C
	ANA D
	ANA E
	ANA H
	ANA L 
	ANA M 
	XRA A 
	XRA B 
	XRA C 
	XRA D 
	XRA E 
	XRA H 
	XRA L 
	XRA M
;opcodes B0-BF
	ORA A 
	ORA B 
	ORA C 
	ORA D 
	ORA E 
	ORA H 
	ORA L 
	ORA M 
	CMP A 
	CMP B 
	CMP C 
	CMP D 
	CMP E 
	CMP H 
	CMP L 
	CMP M
;opcodes C0-CF
	NOP 
	MOV A,B 
	MOV A,C 
	MOV A,D 
	MOV A,E 
	MOV A,H 
	MOV A,L 
	MOV A,M 
	MOV B,A 
	MOV B,B 
	MOV B,C 
	MOV B,D 
	MOV B,E 
	MOV B,H 
	MOV B,L 
	MOV B,M
;opcodes D0-DF
	MOV C,A 
	MOV C,B 
	MOV C,C 
	MOV C,D 
	MOV C,E 
	MOV C,H 
	MOV C,L 
	MOV C,M 
	MOV D,A 
	MOV D,B 
	MOV D,C 
	MOV D,D 
	MOV D,E 
	MOV D,H 
	MOV D,L 
	MOV D,M
;opcodes E0-EF
	MOV E,A 
	MOV E,B 
	MOV E,C 
	MOV E,D 
	MOV E,E 
	MOV E,H 
	MOV E,L 
	MOV E,M 
	MOV H,A 
	MOV H,B 
	MOV H,C 
	MOV H,D 
	MOV H,E 
	MOV H,H 
	MOV H,L 
	MOV H,M
;opcodes F0-FF
	MOV L,A 
	MOV L,B 
	MOV L,C 
	MOV L,D 
	MOV L,E 
	MOV L,H 
	MOV L,L 
	MOV L,M 
	MOV M,A 
	MOV M,B 
	MOV M,C 
	MOV M,D 
	MOV M,E 
	MOV M,H 
	MOV M,L 
	HLT

	END


